## ros-foxy-maliput-py 0.1.5

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_py LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(maliput REQUIRED)
find_package(pybind11 REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_python_install_package("maliput")

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  find_package(ament_cmake_flake8 REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_flake8("--config" ${CMAKE_CURRENT_SOURCE_DIR}/.flake8)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
  ament_doxygen_generate(doxygen_maliput_py
    CONFIG_OVERLAY doc/Doxyfile.overlay.in
    DEPENDENCIES maliput
    TEST_ON_WARNS
  )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Export
##############################################################################

ament_export_dependencies(ament_cmake)
ament_package()

=== test/CMakeLists.txt ===
find_package(ament_cmake_pytest REQUIRED)

add_subdirectory(api)
add_subdirectory(math)

=== src/bindings/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

# api module
pybind11_add_module(api_py
  api_py.cc
  api_rules_py.cc
)

set_target_properties(api_py PROPERTIES OUTPUT_NAME "api")

target_include_directories(api_py
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

target_link_libraries(api_py
  PRIVATE
    maliput::api
    pybind11::module
)

# math module
pybind11_add_module(math_py math_py.cc)

set_target_properties(math_py PROPERTIES OUTPUT_NAME "math")

target_include_directories(math_py
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

target_link_libraries(math_py
  PRIVATE
    maliput::math
    pybind11::module
)

# plugin module
pybind11_add_module(plugin_py plugin_py.cc)

set_target_properties(plugin_py PROPERTIES OUTPUT_NAME "plugin")

target_include_directories(plugin_py
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

target_link_libraries(plugin_py
  PRIVATE
    maliput::plugin
    pybind11::module
)

##############################################################################
# Install
##############################################################################

install(TARGETS api_py
  DESTINATION "${PYTHON_INSTALL_DIR}/maliput"
)

install(TARGETS math_py
  DESTINATION "${PYTHON_INSTALL_DIR}/maliput"
)

install(TARGETS plugin_py
  DESTINATION "${PYTHON_INSTALL_DIR}/maliput"
)

=== test/api/CMakeLists.txt ===
# TODO(francocipollone): Improve this check by wrapping ament_add_pytest_test() function.
# When sanitizers are activated python scripts are disabled.
if (NOT ${SANITIZERS})
  ament_add_pytest_test(api_pytest
    api_test.py
    # Avoid pytest from importing the module stub
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
  ament_add_pytest_test(api_rules_pytest
    api_rules_test.py
    # Avoid pytest from importing the module stub
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
endif()

=== test/math/CMakeLists.txt ===
# TODO(francocipollone): Improve this check by wrapping ament_add_pytest_test() function.
# When sanitizers are activated python scripts are disabled.
if (NOT ${SANITIZERS})
  ament_add_pytest_test(math_pytest
    math_test.py
    # Avoid pytest from importing the module stub
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
endif()

=== debian/changelog ===
ros-foxy-maliput-py (0.1.5-1focal) focal; urgency=high

  * Adds missing Vector bindings. (#74 <https://github.com/maliput/maliput_py/issues/74>)
  * Adds LaneSRange::GetIntersection binding. (#73 <https://github.com/maliput/maliput_py/issues/73>)
  * Contributors: Franco Cipollone

 -- Andrew Best <andrew.best@tri.global>  Mon, 13 Mar 2023 03:00:00 -0000

ros-foxy-maliput-py (0.1.4-1focal) focal; urgency=high

  * Updates ListPlugins binding. (#72 <https://github.com/maliput/maliput_py/issues/72>)
  * Updates triage workflow. (#71 <https://github.com/maliput/maliput_py/issues/71>)
  * Contributors: Franco Cipollone

 -- Andrew Best <andrew.best@tri.global>  Tue, 29 Nov 2022 03:00:00 -0000

ros-foxy-maliput-py (0.1.3-1focal) focal; urgency=high

  * Adds binding for ToSegmentPosition. (#70 <https://github.com/maliput/maliput_py/issues/70>)
  * Contributors: Franco Cipollone

 -- Andrew Best <andrew.best@tri.global>  Wed, 14 Sep 2022 03:00:00 -0000

ros-foxy-maliput-py (0.1.2-1focal) focal; urgency=high

  * Use maliput's method for creating road network via plugin api. (#68 <https://github.com/maliput/maliput_py/issues/68>)
  * Fixes IntersectionBook's bug. (#69 <https://github.com/maliput/maliput_py/issues/69>)
  * Adds triage workflow. (#66 <https://github.com/maliput/maliput_py/issues/66>)
  * Adds TrafficLightBook bindings. (#65 <https://github.com/maliput/maliput_py/issues/65>)
  * Improves README. (#64 <https://github.com/maliput/maliput_py/issues/64>)
  * Contributors: Franco Cipollone

 -- Andrew Best <andrew.best@tri.global>  Thu, 28 Jul 2022 03:00:00 -0000

ros-foxy-maliput-py (0.1.1-1focal) focal; urgency=high

  * Removes pylint and pycodestyle explicit dependency. (#63 <https://github.com/maliput/maliput_py/issues/63>)
  * Contributors: Franco Cipollone

 -- Andrew Best <andrew.best@tri.global>  Thu, 16 Jun 2022 03:00:00 -0000

ros-foxy-maliput-py (0.1.0-1focal) focal; urgency=high

  * Updates package.xml
  * Suppresses old-rule-api-related deprecation warnings. (#62 <https://github.com/maliput/maliput_py/issues/62>)
  * Depends on pybind11 package via rosdep. (#61 <https://github.com/maliput/maliput_py/issues/61>)
  * Uses ros-action-ci in build.yaml workflow. (#59 <https://github.com/maliput/maliput_py/issues/59>)
  * Moves package to root (#60 <https://github.com/maliput/maliput_py/issues/60>)
  * Updates license. (#58 <https://github.com/maliput/maliput_py/issues/58>)
  * Removes dashing CI. (#57 <https://github.com/maliput/maliput_py/issues/57>)
  * Added a binding in RoadPosition for ToInertialPosition method (#56 <https://github.com/maliput/maliput_py/issues/56>)
  * Adds IntersectionBook::FindIntersection(inertial_pos) binding. (#55 <https://github.com/maliput/maliput_py/issues/55>)
  * Merge pull request #54 <https://github.com/maliput/maliput_py/issues/54> from ToyotaResearchInstitute/voldivh/value_range_method_to_state
  * [FEAT]: Changed values() and ranges() method from Rules to states()
  * Adds bindings for new GetState method in the state providers. (#53 <https://github.com/maliput/maliput_py/issues/53>)
  * Adds BUILD_DOCS flag as opt-in flag (#52 <https://github.com/maliput/maliput_py/issues/52>)
  * Adds workflow_dispatch to other workflows. (#51 <https://github.com/maliput/maliput_py/issues/51>)
  * Adds PhaseRingBook bindings (#48 <https://github.com/maliput/maliput_py/issues/48>)
  * Tests maliput::api interfaces (#47 <https://github.com/maliput/maliput_py/issues/47>)
  * Completes RoadNetwork bindings (#46 <https://github.com/maliput/maliput_py/issues/46>)
  * Adds IntersectionBook (#45 <https://github.com/maliput/maliput_py/issues/45>)
  * Adds CI badges (#50 <https://github.com/maliput/maliput_py/issues/50>)
  * Adds Intersection bindings (#44 <https://github.com/maliput/maliput_py/issues/44>)
    Co-authored-by: Franco Cipollone <mailto:53065142+francocipollone@users.noreply.github.com>
  * Adds PhaseProvider bindings (#43 <https://github.com/maliput/maliput_py/issues/43>)
  * Adds PhaseRing bindings (#42 <https://github.com/maliput/maliput_py/issues/42>)
  * Adds Phase bindings. (#41 <https://github.com/maliput/maliput_py/issues/41>)
  * Adds bindings for UniqueBulbId, UniqueBulbGroupId and fixes hashing in other Ids (#40 <https://github.com/maliput/maliput_py/issues/40>)
  * Adds TrafficLight bindings. (#39 <https://github.com/maliput/maliput_py/issues/39>)
  * Adds BulbGroup bindings (#38 <https://github.com/maliput/maliput_py/issues/38>)
  * Adds Bulb bindings. (#37 <https://github.com/maliput/maliput_py/issues/37>)
  * Adds bindings for some Bulb related types (#36 <https://github.com/maliput/maliput_py/issues/36>)
  * Adds bindings for RuleStateProviders. (#35 <https://github.com/maliput/maliput_py/issues/35>)
  * Adds RoadRulebook bindings. (#34 <https://github.com/maliput/maliput_py/issues/34>)
  * Adds bindings for RuleRegistry. (#33 <https://github.com/maliput/maliput_py/issues/33>)
  * Adds DiscreteValueRule and RangeValueRule binding (#32 <https://github.com/maliput/maliput_py/issues/32>)
  * Adds bindings for Rule, Rule::State and UniqueId (#30 <https://github.com/maliput/maliput_py/issues/30>)
  * Replaces push by workflow_dispatch event in gcc build. (#29 <https://github.com/maliput/maliput_py/issues/29>)
  * Completes Lane API bindinds and adds RBounds, HBounds and IsoLaneVelocity. (#28 <https://github.com/maliput/maliput_py/issues/28>)
  * Adds LaneEndSet and BranchPoint (#27 <https://github.com/maliput/maliput_py/issues/27>)
  * Adds LaneEnd binding. (#26 <https://github.com/maliput/maliput_py/issues/26>)
  * Adds python bindings for SRange, LaneSRange and LaneSRoute. (#25 <https://github.com/maliput/maliput_py/issues/25>)
  * Extends LanePosition and ***Id python interface (#24 <https://github.com/maliput/maliput_py/issues/24>)
  * Extends python interface of some maliput.api entities. (#23 <https://github.com/maliput/maliput_py/issues/23>)


=== debian/control ===
Source: ros-foxy-maliput-py
Section: misc
Priority: optional
Maintainer: Andrew Best <andrew.best@tri.global>
Build-Depends: debhelper (>= 9.0.0), pybind11-dev, python3-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-flake8 <!nocheck>, ros-foxy-ament-cmake-pytest <!nocheck>, ros-foxy-maliput, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-py
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pybind11-dev, ros-foxy-maliput, ros-foxy-ros-workspace
Description: Maliput bindings

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-py//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
